
--freemarker template

drop table if exists tmp_studien;
drop table if exists tmp_studien2;

SELECT
SM.semester_tid as semester,
SM.semester_anfang,
SM.semester_ende,
SG.st_absz_nr,
SG.st_skz_nr,
SG.studiengangs_identifikator,
SG.studiengangs_bezeichnung,
SM.st_sem_nr,
ST.st_studium_nr,
S.st_studstamm_nr,
ST.st_studiengang_nr,
SG.studiengangs_typ_kb,
SA.studienstatustyp,
SA.st_studienstatus_nr,
SA.beginn_datum,
SA.gueltig_ab,
val(S.matrikelnummer) as matrikelnummer,
S.geschlecht,
S.ca12_staat,
S.second_nationality,
SG.fachkennzeichen,
ST.studienform_statistik_code,
(case when SG.studiengangs_typ_kb in ('MSG') then SG.st_studiengang_nr else null::integer end) as st_studiengang_nr_msg,
null::integer as st_studiengang_nr_msg_primaerflag,
(case when SG.studiengangs_typ_kb in ('TSG') then SG.st_studiengang_nr else null::integer end) as st_studiengang_nr_tsg,
null::integer as studienfach_sortierung,
null::char(10) as hrst,
null::integer as fachsemester,
null::integer as hssem,
(case when SG.studiengangs_typ_kb in ('TSG') then SA.studienstatustyp else null::char(10) end) as statustyp_tsg,
0::smallint as tsg_generated,
--0::smallint as primaerflag,
null::integer as studiengang_nr,
null::integer as fach_nr,
null::char(10) as unikey,
null::date as anfdat,
null::date as ruebeudat,
null::date as endedat,
null::smallint as kz_rueck_beur_ein,
null::char(10) as hzb_art,
rank () over (partition by SM.st_sem_nr, S.st_studstamm_nr, SG.studiengangs_identifikator  order by SA.gueltig_ab desc) as status_historie
into temp tmp_studien
FROM costage_st_studierendenstammdaten S,
 costage_st_studien ST,
 costage_st_semester SM,
 costage_st_studiengaenge SG ,
 costage_st_studienstatus SA
 

where
S.st_studstamm_nr = ST.st_studstamm_nr
and ST.st_studiengang_nr=SG.st_studiengang_nr
and S.matrikelnummer is not null
--and SM.semester_tid  >= 20171
-- and SM.semester_tid <= 20171
and SG.studiengangs_typ_kb in ('ESG','TSG','MSG')
and SA.st_studium_nr=ST.st_studium_nr
and SA.st_sem_nr=SM.st_sem_nr
and SA.gueltig_ab <=SM.semester_ende --nur letzter Status im jew. Semester interessiert, nicht danach
and (SA.studienstatustyp not in ('Z','X') or (SA.studienstatustyp  in ('Z','X') and SA.gueltig_ab <= today())) --Studis außer erst/neueinschr/rückmeld/beurlaubt werden in der Semestermitte exmatr. zum Endedatum Semesterende, wenn dieses Datum in der Zukunft liegt soll der Studi mit dem vorherigen Status erscheinen
--and SA.studienstatustyp not in ('a','o')
and ${COSTAGE_STUDENT_FILTER}
--group by 1,2,3,4,5,6,7,8,9,10,11,12,13
;


update tmp_studien
set hrst=H.hoererstatus_kb
from costage_st_hoererstatus H
where tmp_studien.st_studstamm_nr = H.st_studstamm_nr
and tmp_studien.st_sem_nr = H.st_sem_nr
;


update tmp_studien
set fachsemester=F.fachsemester
from costage_st_fachsemester F
where F.st_studium_nr=tmp_studien.st_studium_nr
and F.st_sem_nr=tmp_studien.st_sem_nr
and F.fachsemestertyp='FS'
;


update tmp_studien
set hzb_art=H.hzb_art_stla_code
from costage_bw_bewerb_hzb H, costage_bw_bewerbungen BW
where tmp_studien.st_studstamm_nr = BW.st_studstamm_nr
and BW.nr=H.bw_bewrbng_nr
;

create index tmp_ix1 on tmp_studien(st_studiengang_nr);
create index tmp_ix2 on tmp_studien(st_studstamm_nr);
create index tmp_ix3 on tmp_studien(studiengangs_typ_kb);
create index tmp_ix4 on tmp_studien(st_sem_nr);
create index tmp_ix5 on tmp_studien(status_historie);


select T.*,
1::smallint as primaerflag,
null::integer as letztes_tsg_semester
into temp tmp_studien2
from tmp_studien T, costage_st_hauptstudien H
 where H.st_studstamm_nr=T.st_studstamm_nr
 and H.st_studium_nr=T.st_studium_nr
 and H.st_sem_nr=T.st_sem_nr
 and status_historie=1
 and T.studiengangs_typ_kb in ('ESG','TSG')
 ;
--Studiengänge ohne Primärflag:
insert into tmp_studien2
select T.*,
0::smallint as primaerflag,
null::integer as letztes_tsg_semester
from tmp_studien T left outer join costage_st_hauptstudien H
on (H.st_studstamm_nr=T.st_studstamm_nr
 and H.st_studium_nr=T.st_studium_nr
 and H.st_sem_nr=T.st_sem_nr)
 where T.status_historie=1
 and T.studiengangs_typ_kb in ('ESG','TSG')
 and H.st_studstamm_nr is null
  ;



--Ermittlung msg bei TSG:
--es kann pro Studi und Semester und Abschlussziel mehrere MSG geben, 
--daqher zuerst den jeweils letzten ermiteln. Dieser ist dann der Default-MSG:
select st_sem_nr,st_absz_nr,st_studstamm_nr,max(beginn_datum) as beginn_datum
into temp tmp_last_msg_per_term
from tmp_studien 
where  studiengangs_typ_kb='MSG' 
group by 1,2,3
;

--nur Diagnose Einzelschritt:
--select st_studiengang_nr_msg,* from tmp_studien2 where semester=20222
--;

--zuerst den jeweils letzten (=jüngsten) MSG zuweisen:
--TODO: langsam:
update tmp_studien2 set st_studiengang_nr_msg=T.st_studiengang_nr_msg
from tmp_studien T,tmp_last_msg_per_term E, costage_st_studiengaenge_mtsg M
where M.st_studiengang_nr_tsg=tmp_studien2.st_studiengang_nr
and M.st_studiengang_nr_msg=T.st_studiengang_nr_msg
and T.st_sem_nr=tmp_studien2.st_sem_nr
and T.st_studstamm_nr=tmp_studien2.st_studstamm_nr
and E.st_sem_nr=tmp_studien2.st_sem_nr
and E.st_studstamm_nr=tmp_studien2.st_studstamm_nr
and E.st_absz_nr=tmp_studien2.st_absz_nr
and E.beginn_datum=T.beginn_datum
and T.studiengangs_typ_kb='MSG' 
and T.st_absz_nr=tmp_studien2.st_absz_nr
and T.st_studiengang_nr_msg is not null
and tmp_studien2.studiengangs_typ_kb ='TSG'
;
--wenn der jüngste MSG nicht paßt, wird der nächste passende 
--zugewiesen:
update tmp_studien2 set st_studiengang_nr_msg=T.st_studiengang_nr_msg
from tmp_studien T,costage_st_studiengaenge_mtsg M
where M.st_studiengang_nr_tsg=tmp_studien2.st_studiengang_nr
and M.st_studiengang_nr_msg=T.st_studiengang_nr_msg
and T.st_sem_nr=tmp_studien2.st_sem_nr
and T.st_studstamm_nr=tmp_studien2.st_studstamm_nr
and T.studiengangs_typ_kb='MSG' 
and T.st_absz_nr=tmp_studien2.st_absz_nr
and T.st_studiengang_nr_msg is not null
and tmp_studien2.studiengangs_typ_kb ='TSG'
and tmp_studien2.st_studiengang_nr_msg is null
;



--statustyp bei TSG aus MSG nachladen:
update tmp_studien2 set studienstatustyp=S.studienstatustyp
from tmp_studien S
where tmp_studien2.st_studiengang_nr_msg=S.st_studiengang_nr 
and tmp_studien2.st_studstamm_nr=S.st_studstamm_nr
and S.studiengangs_typ_kb ='MSG'
and tmp_studien2.studiengangs_typ_kb ='TSG'
and tmp_studien2.st_sem_nr=S.st_sem_nr
and S.status_historie=1
 
;

drop table tmp_last_msg_per_term;


<#if K_COSTAGE_TSG_GENERATE == 1>

--alle möglichen TSG/MSG-Kombinationen laden:
select T.*,M.st_studiengang_nr_msg as st_studiengang_nr_msg_possible,ST.st_studium_nr as st_studium_nr_msg_possible
into temp tmp_studien3
from tmp_studien2 T, costage_st_studiengaenge_mtsg M, costage_st_studien ST
where ST.st_studiengang_nr=M.st_studiengang_nr_msg
and ST.st_studstamm_nr=T.st_studstamm_nr
and M.st_studiengang_nr_tsg=T.st_studiengang_nr
and T.studiengangs_typ_kb ='TSG'
;


--Start- und Endsemester aller MSG pro Student:
drop table if exists tmp_studien_msg;
select T.st_studiengang_nr as st_studiengang_nr_msg,
T.st_studstamm_nr,
min(T.semester) as startsemester,
max(T.semester) as endsemester
into temp tmp_studien_msg
from tmp_studien T 
where T.studienstatustyp in ('U','B','E','I','X','Z') --nur tatsächlich eingeschrieben
and T.studiengangs_typ_kb ='MSG'--enthält die MSG
and T.status_historie=1
group by 1,2
;
--Verknüpfung mit TSG über alle möglichen Semester:
drop table if exists tmp_studien_msg_tsg;
select distinct 
M.st_studiengang_nr_msg, 
T.st_studiengang_nr as st_studiengang_nr_tsg,
M.st_studstamm_nr,
E.semester_tid as semester,
E.semester_anfang,
E.semester_ende,
E.st_sem_nr,
M.startsemester,
M.endsemester
into temp tmp_studien_msg_tsg
from tmp_studien_msg M, tmp_studien3 T,costage_st_semester E 
where M.st_studiengang_nr_msg=T.st_studiengang_nr_msg_possible
and M.st_studstamm_nr=T.st_studstamm_nr
--and T.semester between M.startsemester and M.endsemester
and E.semester_tid between M.startsemester and M.endsemester
and T.studiengangs_typ_kb ='TSG'
;
--nun fehlende Datensätze ermitteln:
drop table if exists tmp_studien_msg_tsg_fehlend;
select T.*
 into temp tmp_studien_msg_tsg_fehlend
from tmp_studien_msg_tsg T --enthält alle möglichen TSG
left outer   join tmp_studien3 T2 --enthält die tatsächlich vorhandenen TSG
on (T2.st_studiengang_nr_msg_possible=T.st_studiengang_nr_msg
and T2.st_studiengang_nr=T.st_studiengang_nr_tsg
and T2.st_studstamm_nr=T.st_studstamm_nr
and T2.studiengangs_typ_kb ='TSG'
and T.semester=T2.semester)
where T2.st_studstamm_nr is null
;

--fehlende Semester nachtragen:
insert into tmp_studien2(semester,
semester_anfang,
semester_ende,
st_absz_nr,
st_skz_nr,
studiengangs_identifikator,
studiengangs_bezeichnung,
st_sem_nr,
st_studium_nr,
st_studstamm_nr,
st_studiengang_nr,
studiengangs_typ_kb,
--studienstatustyp,
--st_studienstatus_nr,
--beginn_datum,
--gueltig_ab,
matrikelnummer,
geschlecht,
ca12_staat,
second_nationality,
fachkennzeichen,
studienform_statistik_code,
st_studiengang_nr_msg,
st_studiengang_nr_tsg,
hrst,
hssem,
statustyp_tsg,
tsg_generated,
primaerflag,
hzb_art,
fachsemester,
letztes_tsg_semester)
select  M.semester,
M.semester_anfang,
M.semester_ende,
st_absz_nr,
S.st_skz_nr,
S.studiengangs_identifikator,
S.studiengangs_bezeichnung,
M.st_sem_nr,
S.st_studium_nr,
S.st_studstamm_nr,
S.st_studiengang_nr,
S.studiengangs_typ_kb,
--M.studienstatustyp_msg,
--M.st_studienstatus_nr_msg,
--M.beginn_datum,
--M.gueltig_ab,
S.matrikelnummer,
S.geschlecht,
S.ca12_staat,
S.second_nationality,
S.fachkennzeichen,
S.studienform_statistik_code,
M.st_studiengang_nr_msg,
S.st_studiengang_nr_tsg,
null::char(10) as hrst,--hrst kann im Studienverlauf wechseln, daher nachher vom MSG nachladen
S.hssem,
null::char(10) as  statustyp_tsg,
1 as tsg_generated,
0 as primaerflag, --geschlossene TSG können kein Primärflag haben
S.hzb_art,
null::integer as fachsemester,
max(S.semester) 
from tmp_studien_msg_tsg_fehlend M, tmp_studien3 S --,costage_st_semester E 
where M.st_studiengang_nr_msg=S.st_studiengang_nr_msg_possible
and M.st_studiengang_nr_tsg=S.st_studiengang_nr
and M.st_studstamm_nr=S.st_studstamm_nr
and S.studiengangs_typ_kb ='TSG'
and M.semester != S.semester 
--and E.st_sem_nr=M.st_sem_nr
--and S.st_studiengang_nr_msg=34454
--and S.studiengangs_bezeichnung='Bildungswissenschaften'
--and M.semester=20211
group by 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,23,24,25,26,27
;

--statustyp und hrst nachladen:
update tmp_studien2 set studienstatustyp=S.studienstatustyp,
hrst=S.hrst
from tmp_studien S
where tmp_studien2.st_studiengang_nr_msg=S.st_studiengang_nr 
and tmp_studien2.st_studstamm_nr=S.st_studstamm_nr
and S.studiengangs_typ_kb ='MSG'
and tmp_studien2.tsg_generated=1
and tmp_studien2.st_sem_nr=S.st_sem_nr
and S.status_historie=1
 
;

--statustyp_tsg nachladen:
update tmp_studien2 set statustyp_tsg=S.statustyp_tsg,
fachsemester=S.fachsemester
from tmp_studien S
where tmp_studien2.st_studium_nr=S.st_studium_nr 
and tmp_studien2.st_studstamm_nr=S.st_studstamm_nr
and S.studiengangs_typ_kb ='TSG'
and tmp_studien2.tsg_generated=1
and tmp_studien2.letztes_tsg_semester=S.semester
and S.status_historie=1
;

drop table tmp_studien_msg_tsg_fehlend;
drop table tmp_studien_msg_tsg;
drop table tmp_studien_msg;
drop table tmp_studien3;


</#if>
--------------------------------------------------------------------

drop table tmp_studien;

--Ermittlung fach_nr:
update tmp_studien2 set fach_nr=M.studienfach_sortierung
from costage_st_studiengaenge_mtsg M
where M.st_studiengang_nr_msg=tmp_studien2.st_studiengang_nr_msg
and M.st_studiengang_nr_tsg=tmp_studien2.st_studiengang_nr
and tmp_studien2.studiengangs_typ_kb ='TSG'
;

update tmp_studien2 set fach_nr=1
where fach_nr is null;



update tmp_studien2 set unikey=K.unikey
from costage_st_studiengaenge G, costage_st_studienkennzahlen K
where G.st_studiengang_nr=tmp_studien2.st_studiengang_nr
and K.st_skz_nr=G.st_skz_nr
;

update tmp_studien2 set kz_rueck_beur_ein=(select val(astat)
from cifx where key=400 
and apnr=tmp_studien2.studienstatustyp
);

-- update tmp_studien3 set kz_rueck_beur_ein=(select val(astat)
-- from cifx where key=400 
-- and apnr=tmp_studien3.statustyp_tsg
-- )
-- where kz_rueck_beur_ein is null;

update tmp_studien2
set hssem=H.anzahl_hochschulsemester
from costage_st_hochschulsemester H
where H.st_studstamm_nr=tmp_studien2.st_studstamm_nr
and H.st_sem_nr=tmp_studien2.st_sem_nr
;


update tmp_studien2 set studiengang_nr=1 where primaerflag=1;

--Wenn Studium  mit Primärflag ein TSG ist, wird die studiengang_nr auf alle anderen TSG des MSG ausgedehnt: 
select st_studstamm_nr,semester,st_studiengang_nr_msg
into temp tmp_primaer_msg
from tmp_studien2
where studiengangs_typ_kb ='TSG'
and st_studiengang_nr_msg is not null
and primaerflag=1;

--select * from tmp_primaer_msg;

update tmp_studien2 set studiengang_nr=1 where primaerflag=0
and studiengangs_typ_kb ='TSG'
and exists (select st_studiengang_nr_msg
from tmp_primaer_msg T
where T.st_studstamm_nr=tmp_studien2.st_studstamm_nr
and T.semester=tmp_studien2.semester
and T.st_studiengang_nr_msg=tmp_studien2.st_studiengang_nr_msg
)
;

--SPO-Version (letzte im jew. Semester) ermitteln:
select T.*,null::char(10) as po_stp_stp_version_kb,
max(SPO.gueltig_ab) as spo_max_gueltig_ab
into temp tmp_studien3
from tmp_studien2 T left outer join costage_st_studien_spoversionen SPO
on (SPO.st_studium_nr=T.st_studium_nr
and SPO.gueltig_ab < T.semester_ende)
group by 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42
;

update tmp_studien3 set po_stp_stp_version_kb= SPO.po_stp_stp_version_kb
from costage_st_studien_spoversionen SPO
where SPO.st_studium_nr=tmp_studien3.st_studium_nr
and tmp_studien3.spo_max_gueltig_ab =SPO.gueltig_ab;


drop table tmp_studien2;


delete from costage_st_studien_aggr
--provisorisch in Testphase:
where ${COSTAGE_STUDENT_FILTER};

create index ix_tmp_studien2 on tmp_studien3(kz_rueck_beur_ein)
;
insert into costage_st_studien_aggr(
st_studium_nr,
       st_studstamm_nr,
       matrikelnummer,
       st_studiengang_nr,
       st_studiengang_nr_msg,
       st_studienstatus_nr,
       statustyp,
       statustyp_tsg,
       tsg_generated,
       hrst,
       semester,
       fachsemester,
       hssem,
       primaerflag,
       studiengang_nr,
       fach_nr,
       unikey,
       anfdat,
       ruebeudat,
       endedat,
       stufrm,
       kz_rueck_beur_ein,
       hzb_art,
       po_stp_stp_version_kb,
       summe
       )
       
select st_studium_nr,
       st_studstamm_nr,
       matrikelnummer,
       st_studiengang_nr,
       st_studiengang_nr_msg,
       st_studienstatus_nr,
       studienstatustyp,
       statustyp_tsg,
       tsg_generated,
      hrst,
       semester,
       fachsemester,
       hssem,
       primaerflag,
--Nun ist studiengang_nr=1 definiert. Die restlichen werden mit RANK ermittelt:
         (case when studiengang_nr =1 then studiengang_nr
        else 
        dense_rank () over (partition by semester, st_studstamm_nr,studiengang_nr  order by 
         (case when studiengangs_typ_kb='TSG' then st_studiengang_nr_msg  else st_studium_nr end ))+1
         end)
  as studiengang_nr,
        (case when primaerflag =1 then 1
       else 
       dense_rank () over (partition by semester, st_studstamm_nr,studiengang_nr  
       order by primaerflag desc,fach_nr)
        end) as fach_nr,
	unikey,
       beginn_datum as anfdat,
      (case when studienstatustyp not in ('Z','X') then  gueltig_ab 
       else null::date  end) as ruebeudat,
       (case when studienstatustyp in ('Z','X') then gueltig_ab 
       else null::date end) as endedat,
       studienform_statistik_code as stufrm,
       kz_rueck_beur_ein,
       hzb_art,
       po_stp_stp_version_kb,
       1 as summe
       from tmp_studien3
       where kz_rueck_beur_ein is not null
;

-- The below code appends the data for the records having kz_rueck_beur_ein as NULL, this data could be helpful for other diagonostic purpose; here this is segregated 
-- from above to accomodate ranking in  studiengangNummer field
insert into costage_st_studien_aggr(
st_studium_nr,
       st_studstamm_nr,
       matrikelnummer,
       st_studiengang_nr,
       st_studiengang_nr_msg,
       st_studienstatus_nr,
       statustyp,
       statustyp_tsg,
       tsg_generated,
       hrst,
       semester,
       fachsemester,
       hssem,
       primaerflag,
       studiengang_nr,
       fach_nr,
       unikey,
       anfdat,
       ruebeudat,
       endedat,
       stufrm,
       kz_rueck_beur_ein,
       hzb_art,
       po_stp_stp_version_kb,
       summe
       )
       
select st_studium_nr,
       st_studstamm_nr,
       matrikelnummer,
       st_studiengang_nr,
       st_studiengang_nr_msg,
       st_studienstatus_nr,
       studienstatustyp,
       statustyp_tsg,
       tsg_generated,
       hrst,
       semester,
       fachsemester,
       hssem,
       primaerflag,
--Nun ist studiengang_nr=1 definiert. Die restlichen werden mit RANK ermittelt:
        -- (case when studiengang_nr is not null then studiengang_nr
       -- else 
       -- dense_rank () over (partition by semester, st_studstamm_nr,studiengang_nr  order by 
        -- (case when studiengangs_typ_kb='TSG' then st_absz_nr else st_studium_nr end ))+1
        -- end)
 -- as studiengang_nr,
cast (NULL as int)   as studiengang_nr2,
        (case when primaerflag =1 then 1
       else 
       dense_rank () over (partition by semester, st_studstamm_nr,studiengang_nr  
       order by primaerflag desc, fach_nr)
        end) as fach_nr,
       unikey,
       beginn_datum as anfdat,
      (case when studienstatustyp not in ('Z','X') then gueltig_ab 
       else null::date  end) as ruebeudat,
       (case when studienstatustyp in ('Z','X') then gueltig_ab 
       else null::date end) as endedat,
       studienform_statistik_code as stufrm,
       kz_rueck_beur_ein,
       hzb_art,
       po_stp_stp_version_kb,
       1 as summe
       from tmp_studien3
       --where semester = 20202
      -- and matrikelnummer = '5847370'
      where  kz_rueck_beur_ein is  null
       ;
--HZB Data:

update costage_st_studien_aggr set hzb_art=H.hzb_art_stla_code,
hzb_datum=H.zeugnisdatum,
hzb_note=H.hzb_note,
hzb_ort=H.land_sub_r_nr,
hzb_staat=H.land_nr
from costage_bw_bewerb_hzb H, costage_bw_bewerbungen BW
where BW.nr=H.bw_bewrbng_nr
and costage_st_studien_aggr.st_studstamm_nr=BW.st_studstamm_nr
;

--Abmeldungsart:
--zuerst personbezogen:
update costage_st_studien_aggr set abm_art_p=P.st_abm_art_kurzbezeichnung
from costage_st_personen_abmeldungen P, costage_st_semester S, costage_st_abmeldungsarten A
where S.st_sem_nr=P.st_sem_nr
and S.semester_tid=costage_st_studien_aggr.semester
and P.st_studium_nr=costage_st_studien_aggr.st_studium_nr
and A.st_abm_art_kurzbezeichnung=P.st_abm_art_kurzbezeichnung
and A.bezug='P'
;
--dann studienbezogen:
update costage_st_studien_aggr set abm_art_s=P.st_abm_art_kurzbezeichnung
from costage_st_personen_abmeldungen P, costage_st_semester S, costage_st_abmeldungsarten A
where S.st_sem_nr=P.st_sem_nr
and S.semester_tid=costage_st_studien_aggr.semester
and P.st_studium_nr=costage_st_studien_aggr.st_studium_nr
and A.st_abm_art_kurzbezeichnung=P.st_abm_art_kurzbezeichnung
and A.bezug='S'
;

--Beurlaubungs-Art:

update costage_st_studien_aggr set urlaub_art=U.st_urlaub_typ_nr
from costage_st_urlaube U, costage_st_semester S
where S.st_sem_nr=U.st_sem_nr
and S.semester_tid=costage_st_studien_aggr.semester
and U.st_studium_nr=costage_st_studien_aggr.st_studium_nr
;

--Wohnorte:
--zuerst Semesterwohnsitz Ort:
update costage_st_studien_aggr set adresse_ort_s=A.land_kfz_kennzeichen_subregion
from costage_st_adressen A
where A.st_studstamm_nr=costage_st_studien_aggr.st_studstamm_nr
and A.st_adresse_typ='S'
;
--dann Semesterwohnsitz Staat:
update costage_st_studien_aggr set adresse_staat_s=A.st_land_nr
from costage_st_adressen A
where A.st_studstamm_nr=costage_st_studien_aggr.st_studstamm_nr
and A.st_adresse_typ='H'
;
--dann Heimatwohnsitz Ort:
update costage_st_studien_aggr set adresse_ort_h=A.land_kfz_kennzeichen_subregion
from costage_st_adressen A
where A.st_studstamm_nr=costage_st_studien_aggr.st_studstamm_nr
and A.st_adresse_typ='H'
;
--dann Heimatwohnsitz Staat:
update costage_st_studien_aggr set adresse_staat_h=A.st_land_nr
from costage_st_adressen A
where A.st_studstamm_nr=costage_st_studien_aggr.st_studstamm_nr
and A.st_adresse_typ='H'
;

drop table tmp_studien3;
drop table tmp_primaer_msg;


